/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:08:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for Entity.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Entity extends com.google.api.client.json.GenericJson {

  /**
   * The entity's key.
   *
   * An entity must have a key, unless otherwise documented (for example, an entity in
   * Value.entityValue may have no key). An entity's kind is its key's path's last element's kind,
   * or null if it has no key.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Key key;

  /**
   * The entity's properties.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, Property> properties;

  static {
    // hack to force ProGuard to consider Property used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Property.class);
  }

  /**
   * The entity's key.
   *
   * An entity must have a key, unless otherwise documented (for example, an entity in
   * Value.entityValue may have no key). An entity's kind is its key's path's last element's kind,
   * or null if it has no key.
   * @return value or {@code null} for none
   */
  public Key getKey() {
    return key;
  }

  /**
   * The entity's key.
   *
   * An entity must have a key, unless otherwise documented (for example, an entity in
   * Value.entityValue may have no key). An entity's kind is its key's path's last element's kind,
   * or null if it has no key.
   * @param key key or {@code null} for none
   */
  public Entity setKey(Key key) {
    this.key = key;
    return this;
  }

  /**
   * The entity's properties.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, Property> getProperties() {
    return properties;
  }

  /**
   * The entity's properties.
   * @param properties properties or {@code null} for none
   */
  public Entity setProperties(java.util.Map<String, Property> properties) {
    this.properties = properties;
    return this;
  }

  @Override
  public Entity set(String fieldName, Object value) {
    return (Entity) super.set(fieldName, value);
  }

  @Override
  public Entity clone() {
    return (Entity) super.clone();
  }

}
