/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:08:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for Filter.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Filter extends com.google.api.client.json.GenericJson {

  /**
   * A composite filter.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private CompositeFilter compositeFilter;

  /**
   * A filter on a property.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PropertyFilter propertyFilter;

  /**
   * A composite filter.
   * @return value or {@code null} for none
   */
  public CompositeFilter getCompositeFilter() {
    return compositeFilter;
  }

  /**
   * A composite filter.
   * @param compositeFilter compositeFilter or {@code null} for none
   */
  public Filter setCompositeFilter(CompositeFilter compositeFilter) {
    this.compositeFilter = compositeFilter;
    return this;
  }

  /**
   * A filter on a property.
   * @return value or {@code null} for none
   */
  public PropertyFilter getPropertyFilter() {
    return propertyFilter;
  }

  /**
   * A filter on a property.
   * @param propertyFilter propertyFilter or {@code null} for none
   */
  public Filter setPropertyFilter(PropertyFilter propertyFilter) {
    this.propertyFilter = propertyFilter;
    return this;
  }

  @Override
  public Filter set(String fieldName, Object value) {
    return (Filter) super.set(fieldName, value);
  }

  @Override
  public Filter clone() {
    return (Filter) super.clone();
  }

}
