/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:08:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for GqlQuery.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GqlQuery extends com.google.api.client.json.GenericJson {

  /**
   * When false, the query string must not contain a literal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean allowLiteral;

  /**
   * A named argument must set field GqlQueryArg.name. No two named arguments may have the same
   * name. For each non-reserved named binding site in the query string, there must be a named
   * argument with that name, but not necessarily the inverse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GqlQueryArg> nameArgs;

  static {
    // hack to force ProGuard to consider GqlQueryArg used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(GqlQueryArg.class);
  }

  /**
   * Numbered binding site @1 references the first numbered argument, effectively using 1-based
   * indexing, rather than the usual 0. A numbered argument must NOT set field GqlQueryArg.name. For
   * each binding site numbered i in query_string, there must be an ith numbered argument. The
   * inverse must also be true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GqlQueryArg> numberArgs;

  static {
    // hack to force ProGuard to consider GqlQueryArg used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(GqlQueryArg.class);
  }

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String queryString;

  /**
   * When false, the query string must not contain a literal.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getAllowLiteral() {
    return allowLiteral;
  }

  /**
   * When false, the query string must not contain a literal.
   * @param allowLiteral allowLiteral or {@code null} for none
   */
  public GqlQuery setAllowLiteral(java.lang.Boolean allowLiteral) {
    this.allowLiteral = allowLiteral;
    return this;
  }

  /**
   * A named argument must set field GqlQueryArg.name. No two named arguments may have the same
   * name. For each non-reserved named binding site in the query string, there must be a named
   * argument with that name, but not necessarily the inverse.
   * @return value or {@code null} for none
   */
  public java.util.List<GqlQueryArg> getNameArgs() {
    return nameArgs;
  }

  /**
   * A named argument must set field GqlQueryArg.name. No two named arguments may have the same
   * name. For each non-reserved named binding site in the query string, there must be a named
   * argument with that name, but not necessarily the inverse.
   * @param nameArgs nameArgs or {@code null} for none
   */
  public GqlQuery setNameArgs(java.util.List<GqlQueryArg> nameArgs) {
    this.nameArgs = nameArgs;
    return this;
  }

  /**
   * Numbered binding site @1 references the first numbered argument, effectively using 1-based
   * indexing, rather than the usual 0. A numbered argument must NOT set field GqlQueryArg.name. For
   * each binding site numbered i in query_string, there must be an ith numbered argument. The
   * inverse must also be true.
   * @return value or {@code null} for none
   */
  public java.util.List<GqlQueryArg> getNumberArgs() {
    return numberArgs;
  }

  /**
   * Numbered binding site @1 references the first numbered argument, effectively using 1-based
   * indexing, rather than the usual 0. A numbered argument must NOT set field GqlQueryArg.name. For
   * each binding site numbered i in query_string, there must be an ith numbered argument. The
   * inverse must also be true.
   * @param numberArgs numberArgs or {@code null} for none
   */
  public GqlQuery setNumberArgs(java.util.List<GqlQueryArg> numberArgs) {
    this.numberArgs = numberArgs;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getQueryString() {
    return queryString;
  }

  /**
   * @param queryString queryString or {@code null} for none
   */
  public GqlQuery setQueryString(java.lang.String queryString) {
    this.queryString = queryString;
    return this;
  }

  @Override
  public GqlQuery set(String fieldName, Object value) {
    return (GqlQuery) super.set(fieldName, value);
  }

  @Override
  public GqlQuery clone() {
    return (GqlQuery) super.clone();
  }

}
