/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:08:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for Key.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Key extends com.google.api.client.json.GenericJson {

  /**
   * Entities are partitioned into subsets, currently identified by a dataset (usually implicitly
   * specified by the project) and namespace ID. Queries are scoped to a single partition.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PartitionId partitionId;

  /**
   * The entity path. An entity path consists of one or more elements composed of a kind and a
   * string or numerical identifier, which identify entities. The first element identifies a root
   * entity, the second element identifies a child of the root entity, the third element a child of
   * the second entity, and so forth. The entities identified by all prefixes of the path are called
   * the element's ancestors. An entity path is always fully complete: ALL of the entity's ancestors
   * are required to be in the path along with the entity identifier itself. The only exception is
   * that in some documented cases, the identifier in the last path element (for the entity) itself
   * may be omitted. A path can never be empty.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<KeyPathElement> path;

  /**
   * Entities are partitioned into subsets, currently identified by a dataset (usually implicitly
   * specified by the project) and namespace ID. Queries are scoped to a single partition.
   * @return value or {@code null} for none
   */
  public PartitionId getPartitionId() {
    return partitionId;
  }

  /**
   * Entities are partitioned into subsets, currently identified by a dataset (usually implicitly
   * specified by the project) and namespace ID. Queries are scoped to a single partition.
   * @param partitionId partitionId or {@code null} for none
   */
  public Key setPartitionId(PartitionId partitionId) {
    this.partitionId = partitionId;
    return this;
  }

  /**
   * The entity path. An entity path consists of one or more elements composed of a kind and a
   * string or numerical identifier, which identify entities. The first element identifies a root
   * entity, the second element identifies a child of the root entity, the third element a child of
   * the second entity, and so forth. The entities identified by all prefixes of the path are called
   * the element's ancestors. An entity path is always fully complete: ALL of the entity's ancestors
   * are required to be in the path along with the entity identifier itself. The only exception is
   * that in some documented cases, the identifier in the last path element (for the entity) itself
   * may be omitted. A path can never be empty.
   * @return value or {@code null} for none
   */
  public java.util.List<KeyPathElement> getPath() {
    return path;
  }

  /**
   * The entity path. An entity path consists of one or more elements composed of a kind and a
   * string or numerical identifier, which identify entities. The first element identifies a root
   * entity, the second element identifies a child of the root entity, the third element a child of
   * the second entity, and so forth. The entities identified by all prefixes of the path are called
   * the element's ancestors. An entity path is always fully complete: ALL of the entity's ancestors
   * are required to be in the path along with the entity identifier itself. The only exception is
   * that in some documented cases, the identifier in the last path element (for the entity) itself
   * may be omitted. A path can never be empty.
   * @param path path or {@code null} for none
   */
  public Key setPath(java.util.List<KeyPathElement> path) {
    this.path = path;
    return this;
  }

  @Override
  public Key set(String fieldName, Object value) {
    return (Key) super.set(fieldName, value);
  }

  @Override
  public Key clone() {
    return (Key) super.clone();
  }

}
