/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 22:08:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for PropertyExpression.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PropertyExpression extends com.google.api.client.json.GenericJson {

  /**
   * The aggregation function to apply to the property. Optional. Can only be used when grouping by
   * at least one property. Must then be set on all properties in the projection that are not being
   * grouped by. Aggregation functions: first selects the first result as determined by the query's
   * order.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String aggregationFunction;

  /**
   * The property to project.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PropertyReference property;

  /**
   * The aggregation function to apply to the property. Optional. Can only be used when grouping by
   * at least one property. Must then be set on all properties in the projection that are not being
   * grouped by. Aggregation functions: first selects the first result as determined by the query's
   * order.
   * @return value or {@code null} for none
   */
  public java.lang.String getAggregationFunction() {
    return aggregationFunction;
  }

  /**
   * The aggregation function to apply to the property. Optional. Can only be used when grouping by
   * at least one property. Must then be set on all properties in the projection that are not being
   * grouped by. Aggregation functions: first selects the first result as determined by the query's
   * order.
   * @param aggregationFunction aggregationFunction or {@code null} for none
   */
  public PropertyExpression setAggregationFunction(java.lang.String aggregationFunction) {
    this.aggregationFunction = aggregationFunction;
    return this;
  }

  /**
   * The property to project.
   * @return value or {@code null} for none
   */
  public PropertyReference getProperty() {
    return property;
  }

  /**
   * The property to project.
   * @param property property or {@code null} for none
   */
  public PropertyExpression setProperty(PropertyReference property) {
    this.property = property;
    return this;
  }

  @Override
  public PropertyExpression set(String fieldName, Object value) {
    return (PropertyExpression) super.set(fieldName, value);
  }

  @Override
  public PropertyExpression clone() {
    return (PropertyExpression) super.clone();
  }

}
